using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Call_PageField
    /// </summary>
    public partial class T_Call_PageField
    {
        public T_Call_PageField()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Call_PageField");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Call_PageField model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Call_PageField(");
            strSql.Append("F_TaskId,F_FeildId,F_Name,F_DBFieldlName,F_Sort,F_TempId)");
            strSql.Append(" values (");
            strSql.Append("@F_TaskId,@F_FeildId,@F_Name,@F_DBFieldlName,@F_Sort,@F_TempId)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TaskId", SqlDbType.Int,4),
                    new SqlParameter("@F_FeildId", SqlDbType.Int,4),
                    new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DBFieldlName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_TempId", SqlDbType.Int,8)
            };
            parameters[0].Value = model.F_TaskId;
            parameters[1].Value = model.F_FeildId;
            parameters[2].Value = model.F_Name;
            parameters[3].Value = model.F_DBFieldlName;
            parameters[4].Value = model.F_Sort;
            parameters[5].Value = model.F_TempId;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Call_PageField model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Call_PageField set ");
            strSql.Append("F_TaskId=@F_TaskId,");
            strSql.Append("F_FeildId=@F_FeildId,");
            strSql.Append("F_Name=@F_Name,");
            strSql.Append("F_DBFieldlName=@F_DBFieldlName,");
            strSql.Append("F_Sort=@F_Sort");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TaskId", SqlDbType.Int,4),
                    new SqlParameter("@F_FeildId", SqlDbType.Int,4),
                    new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DBFieldlName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_TaskId;
            parameters[1].Value = model.F_FeildId;
            parameters[2].Value = model.F_Name;
            parameters[3].Value = model.F_DBFieldlName;
            parameters[4].Value = model.F_Sort;
            parameters[5].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 更新多条数据
        /// </summary>
        public bool UpdateByTaskId(long taskId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("UPDATE  T_Call_PageField set F_TaskId=@F_TaskId WHERE  F_TaskId=-1");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), new SqlParameter("@F_TaskId", taskId));
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 更新多条数据
        /// </summary>
        public bool UpdateByTempId(int tempId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("UPDATE  T_Call_PageField set F_TaskId=0,F_TempId=@F_TempId WHERE  F_TaskId=-1");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), new SqlParameter("@F_TempId", tempId));
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_PageField ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_PageField ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteByTaskId(int taskId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_PageField ");
            strSql.Append(" where F_TaskId=" + taskId);
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteByTempId(int tempId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_PageField ");
            strSql.Append(" where F_TempId=" + tempId);
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Call_PageField GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_TaskId,F_FeildId,F_Name,F_DBFieldlName,F_Sort from T_Call_PageField ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            Model.T_Call_PageField model = new Model.T_Call_PageField();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_Id"] != null && ds.Tables[0].Rows[0]["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(ds.Tables[0].Rows[0]["F_Id"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_TaskId"] != null && ds.Tables[0].Rows[0]["F_TaskId"].ToString() != "")
                {
                    model.F_TaskId = int.Parse(ds.Tables[0].Rows[0]["F_TaskId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_FeildId"] != null && ds.Tables[0].Rows[0]["F_FeildId"].ToString() != "")
                {
                    model.F_FeildId = int.Parse(ds.Tables[0].Rows[0]["F_FeildId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Name"] != null && ds.Tables[0].Rows[0]["F_Name"].ToString() != "")
                {
                    model.F_Name = ds.Tables[0].Rows[0]["F_Name"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_DBFieldlName"] != null && ds.Tables[0].Rows[0]["F_DBFieldlName"].ToString() != "")
                {
                    model.F_DBFieldlName = ds.Tables[0].Rows[0]["F_DBFieldlName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Sort"] != null && ds.Tables[0].Rows[0]["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(ds.Tables[0].Rows[0]["F_Sort"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_TaskId,F_FeildId,F_Name,F_DBFieldlName,F_Sort ");
            strSql.Append(" FROM T_Call_PageField ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetListView(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM vw_Call_PageField ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_TaskId,F_FeildId,F_Name,F_DBFieldlName,F_Sort ");
            strSql.Append(" FROM T_Call_PageField ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Call_PageField ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Call_PageField T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Call_PageField";
            parameters[1].Value = "F_Id";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}

